#pragma rtGlobals= 2
DefaultFont "Helvetica"


Menu "Analysis"
	Submenu "Packages"
		"Physical Constants",Execute/P "INSERTINCLUDE  \"PhysicalConstants\"";Execute/P "COMPILEPROCEDURES ";Execute/P "PhysicalConstantsInitPackage()";Execute/P "DELETEINCLUDE  \"PhysicalConstants\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load Package of Physical Constants."}
		"FWHM",Execute/P "INSERTINCLUDE  \"FWHM\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load commands for getting FWHM."}
		"spec files",Execute/P "INSERTINCLUDE  \"spec\"";Execute/P "INSERTINCLUDE  \"specMore\"";Execute/P "COMPILEPROCEDURES ";Execute/P "specInitPackage()"
		help = {"Load everything for reading spec files."}
		"Image Display Range", Execute/P "INSERTINCLUDE \"ImageDisplayScaling\", version>=1.41" ; 	Execute/P "COMPILEPROCEDURES "
		help = {"Load procedures that set range of color table based on a Marquee region"}
		// "WinView Reader", Execute/P "INSERTINCLUDE \"WinView\", version>=1.81" ; 	Execute/P "INSERTINCLUDE \"ImageDisplayScaling\", version>=1.41" ; 	Execute/P "COMPILEPROCEDURES "
		"WinView Reader", Execute/P "INSERTINCLUDE \"WinView\", version>=1.81"
		help = {"Load procedures reading and looking at WinView images"}
		SubMenu "X-ray"
			"X-ray Data",Execute/P "INSERTINCLUDE  \"Xray\", version>=2.2";Execute/P "COMPILEPROCEDURES ";Execute/P "ElementDataInitPackage()"
			help = {"Load procedures for providing X-ray data"}
			"  Elements Data",Execute/P "INSERTINCLUDE  \"Elements\", version>=1.5";Execute/P "COMPILEPROCEDURES ";Execute/P "ElementDataInitPackage()"
			help = {"Load procedures for providing data on the elements"}
			"  Cromer-Liberman",Execute/P "INSERTINCLUDE  \"CromerLiberman\", version>=1.6";Execute/P "COMPILEPROCEDURES "
			help = {"Load procedures for providing Cromer-Liberman"}
			"Multi-Layer Reflectivity",Execute/P "INSERTINCLUDE  \"MultiLayerReflectivity\", version>=1.0";Execute/P "COMPILEPROCEDURES "
			help = {"Load procedures calculating x-ray reflectivity from multilayers"}
			"Multiple Reflections",Execute/P "INSERTINCLUDE  \"Umwegs\", version>=1.0";Execute/P "COMPILEPROCEDURES "
			help = {"Load procedures for analyzing Umwegs"}
			"Ion Chamber",Execute/P "INSERTINCLUDE  \"IonChamber3.1\", version>=2.2";Execute/P "COMPILEPROCEDURES ";Execute/P "ionChamberInitPackage()"
			help = {"Load procedures for evaluating ion chamber output"}
			"Lattices",Execute/P "INSERTINCLUDE  \"LatticeSym\", version>=1.0";Execute/P "COMPILEPROCEDURES ";Execute/P "InitLatticeSymPackage()"
			help = {"Load lattice symmetry procedures"}
		End
		"Neutron Scattering Data",Execute/P "INSERTINCLUDE  \"Neutron\", version>=1.0";Execute/P "COMPILEPROCEDURES ";Execute/P "NeutronDataInitPackage()"
		help = {"Load procedures for providing Neutron Scattering Data"}
		"-"
	End
End


Proc spec_GraphGenericStyle() : GraphStyle
	Silent 1
	specGraphGenericStyle()
EndMacro
Function specGraphGenericStyle() : GraphStyle
	if (NumberByKey("IGORVERS",IgorInfo(0))>=5.01)
//		ModifyGraph gfMult=130
		ModifyGraph gfMult=125
	endif
	ModifyGraph/Z tick=2, minor=1, standoff=0
	ModifyGraph lowTrip=0.001

	Wave xwave = XWaveRefFromTrace("",StringFromList(0,TraceNameList("",";",1)))
	if (WaveExists(xwave) && xwave[0]*xwave[Inf]<0)
		ModifyGraph zero(bottom)=2		// if it spans zero, put in zero line
	endif

	if (strlen(AxisInfo("", "top"))<1)
		ModifyGraph/Z mirror(bottom)=1
	endif  
  	if (strlen(AxisInfo("", "right"))<1)
		ModifyGraph/Z mirror(left)=1
	endif

	String list = ImageNameList("",";")
	if (ItemsInList(list)>0)				// there is an image on the plot
		Variable i
		String item=StringFromList(0,list)
		for (i=0;strlen(item)>0;i+=1,item=StringFromList(i,list))
			ModifyImage $item ctab= {*,*,PlanetEarth,1}
		endfor
	endif
End
